org.eclipse.rdf4j.sail.base

## Class DistinctModelReducingUnionIteration

- java.lang.Object
- - org.eclipse.rdf4j.common.iteration.AbstractCloseableIteration<E,X>
  - - org.eclipse.rdf4j.common.iteration.LookAheadIteration<Statement,SailException>
    - - org.eclipse.rdf4j.sail.base.DistinctModelReducingUnionIteration

- All Implemented Interfaces:
    AutoCloseable, CloseableIteration<Statement,SailException>, Iteration<Statement,SailException>

      public class DistinctModelReducingUnionIteration
      extends LookAheadIteration<Statement,SailException>

  An Iteration that takes two source. An iterator and a model.

  For every statement returned by the iterator, that statement is removed from the model. Once the iterator is exhausted, a new filteredStatementsIterator is created by applying the filterable function to the model.

  The point of this iteration is to create a distinct iterator that produces only distinct results in a lazy and mutable manner. This is useful when iterating in a transaction, since the user may have added duplicate statements. On a potential second iteration there will be no need for further deduplication, since the initial deduplication was mutable.

  Model will throw a ConcurrentModificationException if two threads call .remove(...) at the same time or one thread calls .next() on an iterator while another calls .remove(...). This is resolved by synchronizing access to the model and by consuming the entire iterator into an ArrayList, effectively caching the filtered part of the model in memory. There is no overflow to disk for this cache.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Statement` | `getNextElement()` Gets the next element.
    `protected void` | `handleClose()` Called by `AbstractCloseableIteration.close()` when it is called for the first time.

    - ### Methods inherited from class org.eclipse.rdf4j.common.iteration.LookAheadIteration

      `hasNext, next, remove`

    - ### Methods inherited from class org.eclipse.rdf4j.common.iteration.AbstractCloseableIteration

      `close, isClosed`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.common.iteration.Iteration

      `stream`

- - ### Method Detail

    - #### getNextElement

          protected Statement getNextElement()
                                      throws SailException

      Description copied from class: `LookAheadIteration`
      Gets the next element. Subclasses should implement this method so that it returns the next element.
      Specified by:
        `getNextElement` in class `LookAheadIteration<Statement,SailException>`
      Returns:
        The next element, or `null` if no more elements are available.
      Throws:
        `SailException`

    - #### handleClose

          protected void handleClose()
                              throws SailException

      Description copied from class: `AbstractCloseableIteration`
      Called by `AbstractCloseableIteration.close()` when it is called for the first time. This method is only called once on each iteration. By default, this method does nothing.
      Overrides:
        `handleClose` in class `LookAheadIteration<Statement,SailException>`
      Throws:
        `SailException`

Copyright © 2015-2020 Eclipse Foundation. All Rights Reserved.